package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.consoles.FastbootConsoleFactory;
import com.vendor.burn.model.badcheck.BadBlockComposite;
import com.vendor.burn.model.badcheck.BadBlockModel;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.IChecker;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.event.EventType;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.serial.workers.WorkerUtility;
import com.vendor.burn.ui.BurnComposite;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;

public class BadCheckComposite extends BurnComposite {
  private Text informationText;
  
  private Button checkButton;
  
  private Button nandScrubButton;
  
  private BadBlockComposite badBlockComposite;
  
  BadBlockModel badBlockModel;
  
  private static long chipSize;
  
  private String nandScrub = "nandscrub";
  
  private String checkBad = "checkbad";
  
  public BadCheckComposite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
  }
  
  protected void createContents(Composite parent) {
    Composite control = new Composite(parent, 0);
    control.setLayout((Layout)new GridLayout(1, false));
    control.setLayoutData(new GridData(1808));
    this.badBlockComposite = new BadBlockComposite(control, 2048);
    GridData layoutData = new GridData(768);
    layoutData.heightHint = 30;
    this.badBlockComposite.setLayoutData(layoutData);
    this.badBlockModel = this.badBlockComposite.getBadBlock();
    this.informationText = new Text(control, 2570);
    this.informationText.setLayoutData(new GridData(4, 4, true, true, 1, 1));
    this.informationText.setText(Messages.BadCheckComposite_BadInfo + ":\r\n");
    Composite checkComposite = new Composite(control, 0);
    checkComposite.setLayout((Layout)new GridLayout(2, false));
    checkComposite.setLayoutData(new GridData(4, 1, true, false));
    this.checkButton = new Button(checkComposite, 8);
    GridData buttonGridData = new GridData(16777216, 1, true, false, 1, 1);
    buttonGridData.widthHint = 100;
    buttonGridData.heightHint = 30;
    this.checkButton.setLayoutData(buttonGridData);
    this.checkButton.setText(Messages.BadCheckComposite_CheckButton_Text);
    this.checkButton.addListener(13, (Listener)new Object(this));
    this.nandScrubButton = new Button(checkComposite, 8);
    GridData nandScrubGridData = new GridData(16777216, 1, true, false, 1, 1);
    nandScrubGridData.widthHint = 100;
    nandScrubGridData.heightHint = 30;
    this.nandScrubButton.setLayoutData(nandScrubGridData);
    this.nandScrubButton.setText(Messages.BadCheckComposite_EraseButton_Text);
    this.nandScrubButton.addListener(13, (Listener)new Object(this));
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(2, false);
  }
  
  protected void checkBadBlock(String buttonName) {
    IFastbootProgressMonitor monitor = getProgressMonitor();
    monitor.begin();
    IChecker checker = (IChecker)getBurner();
    if (checkStatus(checker.checkBeforeCheck())) {
      monitor.getEvent().setBurner((IBurner)checker);
      if (buttonName.equals(this.checkBad)) {
        checker.check(monitor);
      } else if (buttonName.equals(this.nandScrub)) {
        checker.eraseBad(monitor);
      } 
    } else {
      monitor.finish();
    } 
  }
  
  protected void disableUI(String buttonName) {
    disableUI();
    if (buttonName.equals(this.checkBad)) {
      if (this.checkButton != null && !this.checkButton.isDisposed())
        this.checkButton.setEnabled(false); 
    } else if (buttonName.equals(this.nandScrub) && 
      this.nandScrubButton != null && !this.nandScrubButton.isDisposed()) {
      this.nandScrubButton.setEnabled(false);
    } 
  }
  
  protected void enableUI(String buttonName) {
    enableUI();
    if (buttonName.equals(this.checkBad)) {
      if (this.checkButton != null && !this.checkButton.isDisposed())
        this.checkButton.setEnabled(true); 
    } else if (buttonName.equals(this.nandScrub) && 
      this.nandScrubButton != null && !this.nandScrubButton.isDisposed()) {
      this.nandScrubButton.setEnabled(true);
    } 
  }
  
  public void started(FastbootEvent event) {
    if (event.getBurner() instanceof com.vendor.burn.model.devices.burners.BadCheckBurner) {
      super.started(event);
      if (event.getBurner() == getBurner())
        this.checkButton.setEnabled(false); 
    } 
  }
  
  private String getNandContent(String recieved) {
    StringBuilder sb = new StringBuilder();
    if (recieved != null && recieved.trim().length() != 0) {
      int indexOf = recieved.indexOf("bad blocks:");
      if (indexOf == -1)
        return Messages.BadCheckComposite_No_Bad_Blocks_Found; 
      String[] split = recieved.substring(0, indexOf).split("\n");
      for (String string : split) {
        if (string.trim().length() != 0)
          if (!string.toLowerCase().contains("in:") && !string.toLowerCase().contains("out:"))
            sb.append(string).append("\n");  
      } 
      int indexOf2 = recieved.indexOf("[EOT]");
      if (indexOf2 == -1)
        indexOf2 = recieved.length(); 
      sb.append(recieved.substring(indexOf, indexOf2));
      return sb.toString();
    } 
    return Messages.BadCheckComposite_Nothing_to_display;
  }
  
  public void finished(FastbootEvent event) {
    if (event.getBurner() instanceof com.vendor.burn.model.devices.burners.BadCheckBurner) {
      enableUI(this.checkBad);
      enableUI(this.nandScrub);
      if (event.getBurner() == getBurner()) {
        this.checkButton.setEnabled(true);
        this.nandScrubButton.setEnabled(true);
      } 
      if (event.getType() == EventType.CHECK) {
        String message = event.getMessage();
        if (message != null && message.trim().length() != 0)
          updateDataModel(message); 
      } 
    } 
  }
  
  private void updateDataModel(String message) {
    if (this.informationText.isDisposed())
      return; 
    this.informationText.setText(getNandContent(message));
    chipSize = WorkerUtility.ReceiveHelper.getNandChipSize(message);
    if (chipSize == -1L) {
      try {
        FastbootConsoleFactory.getDefaultConsole().getWarningStream().write("Failed to get Chip size\n");
      } catch (IOException iOException) {}
      return;
    } 
    long blockSize = WorkerUtility.ReceiveHelper.getNandBlockSize(message);
    if (blockSize == -1L) {
      try {
        FastbootConsoleFactory.getDefaultConsole().getWarningStream().write("Failed to get Block size\n");
      } catch (IOException iOException) {}
      return;
    } 
    long[] badblocks = getBadBlocks(message);
    this.badBlockModel.setBadAddress(badblocks);
    this.badBlockModel.setChip(chipSize);
    this.badBlockModel.setBlock((int)blockSize);
    Display.getDefault().asyncExec((Runnable)new Object(this));
    String transfered = getTransfered(badblocks, blockSize);
    this.informationText.append(transfered);
  }
  
  public long getChipSize() {
    return chipSize;
  }
  
  private static String getTransfered(long[] badblocks, long blockSize) {
    StringBuilder sb = new StringBuilder("\r\nTransfered:\r\n");
    for (long l : badblocks) {
      String hexString = Integer.toHexString((int)l);
      for (int i = 0; i < 8 - hexString.length(); i++)
        sb.append("0"); 
      if (blockSize != 0L)
        sb.append(hexString + ":\tindex=" + hexString + "\r\n"); 
    } 
    return sb.toString();
  }
  
  private long[] getBadBlocks(String message) {
    int indexOf = message.indexOf("bad blocks:");
    if (indexOf == -1)
      return new long[0]; 
    int indexOf2 = message.indexOf("[EOT]");
    if (indexOf2 == -1)
      indexOf2 = message.length(); 
    String substring = message.substring("bad blocks:".length() + indexOf, indexOf2);
    List<Long> result = new ArrayList<>();
    String[] split = substring.split("\r\n");
    for (String string : split) {
      if (string.trim().length() != 0)
        try {
          long parseLong = Long.parseLong(string.trim(), 16);
          result.add(Long.valueOf(parseLong));
        } catch (NumberFormatException numberFormatException) {} 
    } 
    long[] relong = new long[result.size()];
    for (int i = 0; i < relong.length; i++)
      relong[i] = ((Long)result.get(i)).longValue(); 
    return relong;
  }
}
